// TaskMaster.js
//
// Automated Task and Quest utility

//	Copyright (c) 2003 by David A. Down (Merlyn of Harvestion)

var Title="TaskMaster", Vers="0.7.1", Title2="Enter Name";
var handler= new EventHandler();	// Global event handler object
var fso = new ActiveXObject("Scripting.FileSystemObject"); // For file functions
var Task= {}, TaskFile=null, TaskName=null, HotKeys= {P:"pause"}; // Default hotkeys
var Schema, NameSchema, Deb=false, Log=false, Chat=false, Hot=false, Quit=false;
var ext= ".task", Vendor=null, FileNbr, Range, Timer, Step=0, Pause=false, PoA=false;
var One=false, Nav=false, Repeat=false, Selected=null, WaitFor=null, Stop=false;
var DidStep=false, DoS=0, DSoA=false, Tab;
var Cmd= {chat:"Chat Msg",dly:"Delay",goto:"Go To",jump:"Jump",move:"Move",note:"Note",
		open:"Open",poz:"Pause",port:"Portal",run:"Run To",use:"Use",wait:"Wait For"};

// Everything starts here
function main() {
	if(skapi.szVersion<"2.1") {Msg("Error: Skunkworks v2.1 or later required."); return;}
	if(include(Title+".xml")) {Msg("Error: "+Title+".xml not found."); return;}
	if(include(Title+".cfg")) Msg("Warning: "+Title+".cfg not found.");
	while(!Quit && skapi.plig>pligNotRunning) { // The game must be running
		while(skapi.plig<pligInWorld) { // Wait until logged in
			if(skapi.plig==pligNotRunning) return; // Quit on game termination
			skapi.WaitEvent(1000);		// Wait for a status change
		}
		DefineHandlers();		//	Prepare to handle control events.
		Msg("Version "+Vers+" starting.");
		skapi.ShowControls(Schema,true); // Display the control panel
		FindFiles();			// Build the file list menu

	//	Process events until the Quit flag is set or we log out
		while(!Quit && skapi.plig>pligAtLogin) { // Make sure we're logged in
			skapi.WaitEvent();
		}
		if(Schema) skapi.RemoveControls(Title); // Remove the control panel
		if(Hot) for(key in HotKeys) skapi.Hotkey(key,false); // Remove the hotkeys
		RemoveHandlers();		// Remove the control handlers
	}
}

function ChatMsg(str) { // Send output to the chat window
	if(Chat && Chat!=true) str= Chat+" "+str;	// Prefix string?
	if(!skapi.fInChatBuffer) skapi.Keys("{tab}");	// Activate chat window
	skapi.PasteSz(str);			// Output string
	skapi.Keys("{RETURN}");		// Enter the text
}

function FindFiles() {	// Build a list of '.task' files
	var len= ext.length, sel=-1;
	var dir= fso.GetFolder("."); 	// Get the default directory
	var fc= new Enumerator(dir.Files); // Get the file collection
	FileNbr= 0, TaskFile=null;		// Reset file count
	for(;!fc.atEnd();fc.moveNext()) { // Process all the entries
//		var path= fc.item();		// Get the next file path
		var name= fso.GetFile(fc.item()).Name; // simple filename
		if(name.slice(name.length-len)!=ext) continue;
		skapi.GetControlProperty(Title,"cmFile","AddChoice('"+name+"')");
		if(name==Title+ext) sel= FileNbr; // Default name?
		FileNbr++;					// Inc file count
	}
	Timer= skapi.TimerNew();		// Create a timer object
	Timer.tag= "step";				// Tag for step timer
	if(sel>=0) skapi.SetControlProperty(Title,"cmFile","Selected",sel);
	Tab= 0;							// Default tab
	if(DSoA) SetCtlCheck("cbDSoA",true);
	if(Hot) SetCtlCheck("cbHot",true);
	if(PoA) SetCtlCheck("cbPoA",true);
	if(Stop) SetCtlCheck("cbStop",true);
}

function Hex(nbr) {	// Return the unsigned hexadecimal string for a number
	var rbits= 0x10000 + (0xffff & nbr);
	var lbits= 0x10000 + (nbr >>> 16);
	return "0x"+lbits.toString(16).slice(1)+rbits.toString(16).slice(1);
}

function include(name) { // Include the evaluated contents of a file
    var ForReading=1;
    if(Log) Msg("Including file '"+name+"'.");
	if(!fso.FileExists(name)) return -1; // Does the data file exist?
	cf = fso.OpenTextFile(name,ForReading);
	eval(cf.ReadAll());				// Evaluate the file contents
	cf.Close();
	return 0;
}

function Msg(str) {		// Send output to the message window
	if(Chat) {ChatMsg(Title+": "+str); return;} // Send to chat?
	if(Deb) {skapi.OutputLine(str,opmDebugLog); return;} // Send to debug?
	skapi.OutputSz(Title+": ",opmChatWnd,cmcRose); // Message prefix
	skapi.OutputLine(str,opmChatWnd);	// Output string to message window
}

// Generate a text string representation of an object that can be evaluated to restore it
function ObjectToString(item,wrap) {
	var name,list="";
	if(typeof(item)=="undefined") return "undefined";
	if(item==null) return "null";
	if(typeof(item)=="string") return '"'+item+'"';
	if(typeof(item)!="object") return item.toString();
	for(name in item) {			// Loop through all the object properties
		if(list) list += ",";	// Use delimiter after first property
		if(wrap) list += "\n  ";	// Start new line for sub-object?
		if(name.indexOf("'")<0) list += "'"+name+"':"; // Use (')?
		else list += '"'+name+'":'; // Alternate quotes
		list += ObjectToString(item[name]); // Expand each element
	}
	if(wrap) list += "\n";		// Start new line for ending?
	return "{"+list+"}";
}

function SaveCfg(filename) {	// Save configuration data
	var ForWriting=2;
	cf = fso.OpenTextFile(filename, ForWriting, true);	// Create config file
	cf.WriteLine("// TaskMaster configuration data.  Be careful to preserve the syntax!\n");
	cf.WriteLine("HotKeys = "+ObjectToString(HotKeys,false)+";");
	cf.WriteLine("DSoA = "+DSoA+";");
	cf.WriteLine("Hot = "+Hot+";");
	cf.WriteLine("PoA = "+PoA+";");
	cf.WriteLine("Stop = "+Stop+";");
	cf.Close();
}

function SaveTask(filename) {	// Save task list
	var ForWriting=2;
	cf = fso.OpenTextFile(filename, ForWriting, true);	// Create config file
	cf.WriteLine("// Task detail data.  Do not edit unless you are sure of the structure!\n");
	cf.WriteLine("Task = "+ObjectToString(Task,true)+";\n");
	cf.Close();
}

function SetCtlCheck(control,state) { // Set the check box of a control
	skapi.SetControlProperty(Title,control,"checked",state);
}

// *** Task routines runtimes ***

function DeleteStep(step) {			// Delete a step
	var last= Task[TaskName][0]--;	// Decrement step count
	for(n=step;n<last;n++) Task[TaskName][n]= Task[TaskName][n+1]; // Copy
	delete Task[TaskName][last];	// Delete the end step
}

function DoneStep() {				// The current task step finished
	if(!Step || (Pause && DoS!=Step) || WaitFor || DidStep) return; // Ignore?
	if(Log) Msg("Done step #"+Step);
	Nav= false, DidStep= true;
	if(!Repeat) {					// Advance a step?
		++Step, DoS= 0;
		if(One || Tab==2) {			// One-step?
			PauseTask(One);
			if(Tab==2) ShowStep();	// Update panel?
			return;
		}
	}
	Timer.cmsec= -1;				// Trigger next step
}

function DoStep(SO) {				// Perform the next task step
	var CurStep, cmt, sn, val;
	if(SO) CurStep= SO;				// Explicit step?
	else {
		if(!Step) {Msg("Warning: No next task step."); return;} // Sanity check
		if(Step>Task[TaskName][0]) {	// Past the last step?
			StopTask(false);
			Msg("Task completed");
			return;
		}
		CurStep= Task[TaskName][Step]; // Get the current step object
	}
	val= CurStep.val ? CurStep.val : 1; // Default to one
	cmt= CurStep.cmt ? ",  "+CurStep.cmt : "";
	sn= "Step #"+Step+", ";
	Repeat= DidStep= false;			// Reset
	switch(CurStep.cmd) {
	case "chat":					// Display chat message
		ChatMsg(CurStep.cmt);
		Step++, DidStep= true;		// Advance to next step
		Timer.cmsec= -100*val;		// Trigger next step after delay
		break;
	case "dly":						// Delay for a time
		Step++, DidStep= true;		// Advance to next step
		Timer.cmsec= -100*val;		// Trigger next step after delay
		Msg(sn+"Delaying "+val/10+" sec"+cmt);
		break;
	case "goto":					// Go to a location
		var s="", time, stop=Stop, walk=false;
		if(CurStep.opt) {			// Options set?
			walk= CurStep.opt&2;	// Walk option?
			if(CurStep.opt&1) stop= true; // Stop option
		}
		if(SO) stop= true;			// Force stop?
		if(!walk && val<4) val= 4;	// run hangs at dest. if too small
		var mloc= skapi.MaplocFromSz(CurStep.loc); // Map location
		var speed= walk ? 0.01 : skapi.vRun;
		time= skapi.maplocCur.Dist3DToMaploc(mloc)/speed; // Run time
		if(time<90) s= "(~"+Math.round(time)+" sec)";
		else s= "(~"+(time/60).toFixed(1)+" min)";
		skapi.GoToMaploc(mloc,val/1000,walk,stop,time*2000);
		Msg(sn+(walk?"Walk":"Runn")+"ing to "+CurStep.loc+s+cmt);
		Nav= true;
		break;
	case "jump":					// Do a jump
		DidStep= Nav= true;			// Don't advance step after turning
		skapi.TurnToHead(CurStep.loc); // Turn to compass heading
		skapi.WaitEvent(900,wemSpecific,evidOnAssessItem); // Wait for completion
		var shift= CurStep.opt&2 ? "~" : "";
		skapi.Keys(cmidJump,kmoDown); // Prepare to jump
		skapi.Sleep(val*10);		// Let the jump power build
		skapi.Keys(shift+cmidWalkForward,kmoDown); // Start walking
		skapi.Keys(cmidJump+cmidWalkForward+shift,kmoUp); // Activate the jump
		if(Step) Step++;			// Advance to next step
		Timer.cmsec= -1500;			// Trigger next step after delay
		DidStep= Nav= false;
		Msg(sn+"Jumping "+val+" units"+cmt);
		break;
	case "move":					// Move item
		var aco= skapi.AcoFindInInv(CurStep.sel); // Locate item
		if(!aco) {					// Quit if not found
			Msg("Unable to locate object, "+CurStep.sel);
			StopTask(true);			// Stop the task
			break;
		}
		var target= Getaco(CurStep); // Try to find the target
		if(!target) break;			// Quit if not found
		if(val) {			// Select a quantity?
			if(val<aco.citemStack) { // Do we have too many?
				skapi.SelectAco(aco); // Select for splitting
				skapi.Keys(cmidSplitSelected+val+"{tab}");
			}
		}
		if(CurStep.give) {			// Is this a give?
			aco.MoveToStack(target); // Initiate the give
			Msg(sn+"Giving "+CurStep.sel+" to "+CurStep.name+cmt);
			break;
		}
		aco.MoveToContainer(target); // Initiate the move
		Msg(sn+"Moving "+CurStep.sel+" to "+CurStep.name+cmt);
		break;
	case "note":					// Note is a null step
		Step++;						// Advance to next step
		Timer.cmsec= -1;			// Trigger next step
		Msg(sn+"Note"+cmt);
		break;
	case "open":					// Open an object
		var aco= Getaco(CurStep);	// Try to find object
		if(!aco) break;				// Quit if not found
		skapi.AssessAco(aco);		// Force an object assess
		skapi.WaitEvent(900,wemSpecific,evidOnAssessItem); // Wait for completion
		if(aco.oai && aco.oai.ibi.fOpen) { // Already open?
			Msg(sn+CurStep.name+" is open"+cmt);
			if(Step) Step++;		// Advance to next step
			Timer.cmsec= -100;		// Trigger next step after delay
			break;
		}
		aco.Use();					// Use it
		Msg(sn+"Opening "+CurStep.name+cmt);
		break;
	case "port":					// Use a portal
		var aco= Getaco(CurStep);	// Try to find object
		if(!aco) break;				// Quit if not found
		WaitFor= true;				// Ignore action complete
		aco.Use();					// Use it
		Msg(sn+"Using portal "+CurStep.name+cmt);
		break;
	case "poz":						// Pause the task
		PauseTask(false);
		Msg(sn+"Pausing"+cmt);
		Step++;						// Advance to next step
		break;
	case "use":						// Use an object
		var aco= null;
		if(CurStep.sel) {			// Use on?
			aco= skapi.AcoFindInInv(CurStep.sel); // Locate item
			if(!aco) {				// Quit if not found
				Msg("Unable to locate object, "+CurStep.sel);
				StopTask(true);		// Stop the task
				break;
			}
		}
		var target= Getaco(CurStep); // Try to find target
		if(!target) break;			// Quit if not found
//		Timer.cmsec= -900;			// Trigger next step after delay
		if(aco) {					// Use on?
			aco.UseOnAco(target);	// Use on target
			Msg("Using "+CurStep.sel+" on "+CurStep.name+cmt);
			break;
		}
		target.Use();				// Use it
		Msg(sn+"Using "+CurStep.name+cmt);
		break;
	case "wait":					// Wait for an object
		var name= CurStep.name;
		aco= skapi.AcoFromSz(name); // Try to find the name
		if(aco) {					// Advance if object found
			Msg(sn+"Found "+name);
			++Step;
			Timer.cmsec= -1;		// Trigger next step
			break;
		}
		WaitFor= name;				// Save target
		Msg(sn+"Waiting for "+name+cmt);
		break;
	default: Msg("Step #"+Step+", unimplemented command: "+CurStep.cmd);
		StopTask(true);				// Stop the task
	}
}

function Getaco(CurStep) {			// Try to locate an aco
	var aco= skapi.AcoFromOid(CurStep.id); // Try to locate by ID
	if(aco) return aco;				// Return object if found
	var loc= CurStep.loc;
	if(loc) {						// Do we have a location for it?
		var mloc= skapi.MaplocFromSz(loc); // Convert to maploc
		var dist= skapi.maplocCur.Dist2DToMaploc(mloc); // Get distance
		if(dist>0.3) {				// Out of radar range?
			Repeat= Nav= true;		// This step will repeat on arrival
			skapi.GoToMaploc(mloc,0.1,false,false); // Start running there
			Msg("Running to "+CurStep.loc+" to find "+CurStep.name);
			return false;			// Exit.
		}
	}
	aco= skapi.AcoFromSz(CurStep.name); // Try to find the name
	if(aco) return aco;				// Return object if found
	Msg("Unable to locate object, "+CurStep.name);
	StopTask(true);					// Stop the task
	return false;					// Error exit value
}

function InsertStep(step) {			// Insert a blank step
	var n= Task[TaskName][0]++;		// Increment step count
	for(;n>=step;n--) Task[TaskName][n+1]= Task[TaskName][n]; // Copy
	Task[TaskName][step]= {cmd:"note"};
}

function PauseTask(msg) {			// Pause the current task
	if(Deb && !msg) Msg("Pause task called.");
	skapi.SetControlProperty(Title,"pbPause","text","Resume");
	if(Nav) skapi.CancelNav();		// Navigation in progress?
	else skapi.Keys(cmidReady);		// Just stop moving
	if(skapi.KeyState(cmidWalkForward)) { // Bad key state?
		skapi.Keys(cmidWalkForward+cmidHoldRun+"{shift}",kmoUp); // Reset
	}
	if(msg) Msg("Pausing "+TaskName+" at step #"+Step);
	Pause= true;
	Nav= false;
}

function ShowStep() {				// Display step in edit panel
	var SO= {cmd:"note",cmt:"(no step selected)"};
	if(Deb) Msg("Show step called.");
	if(Step>Task[TaskName][0]) StopTask(false);	// Past the last step?			;
	if(Step) SO= Task[TaskName][Step]; // Select the step
	skapi.SetControlProperty(Title,"stStep","text","Step # "+Step);
	skapi.SetControlProperty(Title,"stCmd","text",Cmd[SO.cmd]);
	var label= SO.cmd=="jump" ? "Heading: " : "Location: ";
	var loc= SO.loc ? label+SO.loc : "";	// Location, etc
	skapi.SetControlProperty(Title,"stArg","text",loc);
	var name= SO.name ? "Name: "+SO.name : ""; // Target name
	skapi.SetControlProperty(Title,"stName","text",name);
	var sel= SO.sel ? "Select: "+SO.sel : ""; // Selection name
	skapi.SetControlProperty(Title,"stSel","text",sel);
	var val= SO.val ? SO.val : "";		// Value
	var stop= SO.opt ? SO.opt&1 : false; // Stop
	if(val<0) val= -val, stop=true;		// Stop flag?
	skapi.SetControlProperty(Title,"ebEVal","text",val);
	skapi.SetControlProperty(Title,"cbESoM","checked",stop);
	var walk= SO.opt ? SO.opt&2 : false; // Walk
	skapi.SetControlProperty(Title,"cbEWalk","checked",walk);
	var cmt= SO.cmt ? SO.cmt : "";		// Comment
	skapi.SetControlProperty(Title,"ebECmt","text",cmt);
}

function ShowTasks() {				// Build the task menu
	for(name in Task) {				// Loop through all the task names
		if(name=="0" || name=="cmt") continue; // Ignore index & comment
		skapi.GetControlProperty(Title,"cmTask","AddChoice('"+name+"')");
	}
}

function StopTask(msg) {			// Stop the current task
	if(Pause) skapi.SetControlProperty(Title,"pbPause","text","Pause");
	Step= 0, Pause= false;			// Stop the task
	skapi.SetControlProperty(Title,"pbStart","text","Start Task");
	if(Nav) skapi.CancelNav();		// Navigation in progress?
	else skapi.Keys(cmidReady);		// Just stop moving
	if(skapi.KeyState(cmidWalkForward)) { // Bad key state?
		skapi.Keys(cmidWalkForward+cmidHoldRun+"{shift}",kmoUp); // Reset
	}
	Nav= false;
	if(msg) Msg("Stopping "+TaskName);
}

// *** Special routines for control events ***

function AddStep(command,target,value,comment) {
	var SO, step= Step;			// Get the step counter
	if(!step) step= ++Task[TaskName][0]; // Increment step counter
	if(target) {					// Is a target defined?
		if(typeof target=="object") {
			var name= target.szName; // Get object name
			var id= target.oid;		// Get object ID
			SO= Task[TaskName][step]= {cmd:command,name:name,id:id};
			var mloc= target.maploc; // Check for a location
			if(mloc) SO.loc= mloc.sz(3); // Save the location?
		} else SO= Task[TaskName][step]= {cmd:command,loc:target};
	} else SO= Task[TaskName][step]= {cmd:command};
	if(value && value!=1) SO.val= value; // Add a value?
	if(comment) {					// Got a comment to add?
		SO.cmt= comment;
		skapi.SetControlProperty(Title,"ebCmt","text",""); // Clear comment field
	}
	Msg(Cmd[command]+" added as step #"+step);
	if(Step && Step<Task[TaskName][0]) Step++; // Increment step #?
	return SO;
}

function CheckRange(text,ctl) {		// Convert and check value
	Range= text ? parseInt(text) : 0; // Convert to number, null=0
	if(isNaN(Range)) Range= -1;		// non-numeric?
	if(Range>=0) return Range;		// Return if valid
	Msg("Value should be a positive number.");
	skapi.GetControlProperty(Title,ctl,"Capture"); // Reactivate the edit
	return -1;
}

function GetRange() {				// Get the slider setting
	Range= 5;						// Set default
	skapi.GetControlProperty(Title,"sRange","SliderPosition"); // Get slider setting
	skapi.WaitEvent(200,wemSpecific,evidOnControlProperty); // Wait for completion
	return Range;
}

function PauseRes() {				// Pause or resume task
	if(!TaskName) {Msg("No task has been selected."); return;}
	if(!Step) {Msg("The task isn't active."); return;}
	if(!Pause) {PauseTask(true); return;} // Do a pause?
	Pause= false;
	skapi.SetControlProperty(Title,"pbPause","text","Pause");
	Timer.cmsec= -1;				// Trigger next step
}

function NewFile(name,comment) {	// Start a new task file
	Task= {'0':0};					// Create a new task object
	RenameFile(name,comment);		// Set the new name
	TaskName= null;					// No task selected
	skapi.GetControlProperty(Title,"cmTask","Clear"); // Clear the task menu
}

function NewTask(name,comment) {	// Start a new task
	Task[name]= {'0':0,cmt:comment}; // Create a new sub-task object
	TaskName= name;					// Save the new name as the current task
	skapi.GetControlProperty(Title,"cmTask","AddChoice('"+name+"')"); // Add to menu
	skapi.SetControlProperty(Title,"cmTask","Selected",Task[0]++); // Select it
	skapi.SetControlProperty(Title,"nbTab","activetab",1); // Select the Add tab
}

function RenameFile(name,comment) {	// Rename a task file
	if(name.slice(name.length-ext.length)!=ext) name += ext; // Add filename extension?
	TaskFile= name;					// Set the new filename
	skapi.GetControlProperty(Title,"cmFile","AddChoice('"+name+"')"); // Add to menu
	skapi.SetControlProperty(Title,"cmFile","Selected",FileNbr++); // Select it
	Task.cmt= comment;				// Set the file comment
}

// ***** Event handler functions start here *****

// Function to set up event handlers
function DefineHandlers() {
	skapi.AddHandler(evidOnActionComplete, handler);
	skapi.AddHandler(evidOnAddToInventory, handler);
	skapi.AddHandler(evidOnAdjustStack, handler);
	skapi.AddHandler(evidOnApproachVendor, handler);
	skapi.AddHandler(evidOnCommand, handler);
	skapi.AddHandler(evidOnControlEvent, handler);
	skapi.AddHandler(evidOnControlProperty, handler);
	skapi.AddHandler(evidOnEndPortalSelf, handler);
	skapi.AddHandler(evidOnHotkey, handler);
	skapi.AddHandler(evidOnLeaveVendor, handler);
	skapi.AddHandler(evidOnMeleeLastAttacker, handler);
	skapi.AddHandler(evidOnNavStop, handler);
	skapi.AddHandler(evidOnObjectCreate, handler);
	skapi.AddHandler(evidOnOpenContainer, handler);
	skapi.AddHandler(evidOnRemoveFromInventory, handler);
	skapi.AddHandler(evidOnSpellFailSelf, handler);
	skapi.AddHandler(evidOnTimer, handler);
}

// Function to remove event handlers
function RemoveHandlers() {
	skapi.RemoveHandler(evidOnActionComplete, handler);
	skapi.RemoveHandler(evidOnAddToInventory, handler);
	skapi.RemoveHandler(evidOnAdjustStack, handler);
	skapi.RemoveHandler(evidOnApproachVendor, handler);
	skapi.RemoveHandler(evidOnCommand, handler);
	skapi.RemoveHandler(evidOnControlEvent, handler);
	skapi.RemoveHandler(evidOnControlProperty, handler);
	skapi.RemoveHandler(evidOnEndPortalSelf, handler);
	skapi.RemoveHandler(evidOnHotkey, handler);
	skapi.RemoveHandler(evidOnLeaveVendor, handler);
	skapi.RemoveHandler(evidOnMeleeLastAttacker, handler);
	skapi.RemoveHandler(evidOnNavStop, handler);
	skapi.RemoveHandler(evidOnObjectCreate, handler);
	skapi.RemoveHandler(evidOnOpenContainer, handler);
	skapi.RemoveHandler(evidOnRemoveFromInventory, handler);
	skapi.RemoveHandler(evidOnSpellFailSelf, handler);
	skapi.RemoveHandler(evidOnTimer, handler);
}

// Constructor function for the event handler object.
function EventHandler() {
	this.OnActionComplete = OnActionComplete;
	this.OnAddToInventory = OnAddToInventory;
	this.OnAdjustStack = OnAdjustStack;
	this.OnApproachVendor = OnApproachVendor;
	this.OnCommand = OnCommand;
	this.OnControlEvent = OnControlEvent;
	this.OnControlProperty = OnControlProperty;
	this.OnEndPortalSelf = OnEndPortalSelf;
	this.OnHotkey = OnHotkey;
	this.OnLeaveVendor = OnLeaveVendor;
	this.OnMeleeLastAttacker = OnMeleeLastAttacker;
	this.OnNavStop = OnNavStop;
	this.OnObjectCreate = OnObjectCreate;
    this.OnOpenContainer = OnOpenContainer;
    this.OnRemoveFromInventory = OnRemoveFromInventory;
    this.OnSpellFailSelf = OnSpellFailSelf;
    this.OnTimer = OnTimer;
}

// Handler function for the OnActionComplete event.
function OnActionComplete() {
	if(Log || Deb) Msg("Action completed.");
	if(Nav) return; // Ignore if moving
	DoneStep();		// Advance step if appropriate
}

// Handler function for the OnAddToInventory event.
function OnAddToInventory(aco) {
	if(Nav) return; // Ignore if moving
	if(Deb) Msg("OnAddToInventory called.");
	DoneStep();		// Advance step if appropriate
}

// Handler function for the OnAdjustStack event.
function OnAdjustStack(aco) {
	if(Nav) return; // Ignore if moving
	if(Deb) Msg("OnAdjustStack called.");
	DoneStep();		// Advance step if appropriate
}

// Handler function for the OnApproachVendor event.
function OnApproachVendor(acoMerchant,mcmBuy,cpyMaxBuy,fractBuy,fractSell,coaco) {
	Vendor= new Object;
	Vendor.aco= acoMerchant;			// Vendor object
	Vendor.buys= mcmBuy;				// Buy categories
	Vendor.max= cpyMaxBuy;				// Maximum buy price
	Vendor.buypct= fractBuy;			// The percent of list price paid
	Vendor.sellpct= fractSell;			// The selling markup
	Vendor.stock= coaco;				// List of vendor's stock
}

// Handler function for the OnCommand event.
function OnCommand(cmd) {
	word = cmd.split(" ");
	switch(word[0]) {
	case "chat":	// Toggle logging to chat
		if(word.length>1) {
			Chat= word[1];
		} else Chat= !Chat;
		Msg("Chat logging is "+(Chat ? "on" : "off"));
		break;
	case "deb":		// Toggle logging detailed messages
		Deb = !Deb;
		Msg("Debug logging is "+(Deb ? "on" : "off"));
		break;
	case "dsoa":		// Toggle do-step-on-add
		DSoA = !DSoA;
		if(Schema) SetCtlCheck("cbDSoA",DSoA); // Switch the control check box
		Msg("Do Step on Add is "+(DSoA ? "on" : "off"));
		break;
	case "eval":	// Display the expression's value
		try {Msg(eval(cmd.slice(5)));}
		catch(err) {Msg("Error during eval: "+err.description);}
		break;
	case "go":		// Go to a location
		if(word.length<3) {Msg("Go where?"); break;}
		var s,loc= cmd.slice(3);
		var mloc= skapi.MaplocFromSz(loc); // Convert to maploc
		if(!mloc) {Msg("Invalid location, '"+loc+"'."); break;}
		var dist= skapi.maplocCur.Dist3DToMaploc(mloc); // Get distance
		var time= dist/skapi.vRun; // Get run time at current speed
		if(time<90) s= Math.round(time)+" sec";
		else s= (time/60).toFixed(1)+" min";
		Msg("Moving to "+loc+", Dist="+dist.toFixed(2)+", Time="+s);
		skapi.GoToMaploc(mloc,0.005,false,true,time*2000);
		break;
	case "hot":		// Toggle hot-key usage
		var key;
		Hot = !Hot;
		SetCtlCheck("cbHot",Hot); // Switch the control check box
		for(key in HotKeys) skapi.Hotkey(key,Hot);
		Msg("Hot keys are "+(Hot ? "on" : "off"));
		break;
	case "id":		// Display selected object's ID
		var aco= skapi.acoSelected;
		if(!aco) {Msg("Nothing is selected."); break;}
		Msg("Selected ID="+Hex(aco.oid)+", icon="+aco.icon);
		Msg("Object type="+aco.oty.toString(16)+", category="+aco.ocm.toString(16));
		Msg("Merchant type="+aco.szMcm+", category="+aco.mcm.toString(16));
		var mloc= aco.maploc;	// Where is it located?
		if(!mloc) break;		// Skip if no location
		var dist= skapi.maplocCur.Dist2DToMaploc(mloc); // Get distance
		Msg("Distance is "+dist.toFixed(3));
		break;
	case "key":		// List or define keys
		if(word.length<2) {		// No argument = list keys
			var key, str= "";
			for(key in HotKeys) {
				if(str!="") str += ", "; // Add separator?
				str += key+"="+HotKeys[key];
			}
			if(str=="") Msg("No hotkeys are defined.");
			else Msg("Defined keys: "+str);
			break;
		}
		if(word.length<3) {		// One argument = delete key
			var key= word[1];
			if(!HotKeys[key]) {Msg("HotKey not defined: "+key); break;}
			if(Hot) skapi.Hotkey(key,false); // Disable the key
			delete HotKeys[key]; // Undefine the key
			Msg("HotKey deleted: "+key);
			break;
		}
		var key= word[1];
		if(key.length!=1) {Msg("HotKeys must be a single key"); break;}
		HotKeys[key]= word[2];	// Define the key
		if(Hot) skapi.Hotkey(key,true); // Enable the key
		Msg("HotKey '"+key+"' defined as: "+word[2]);
		break;
	case "list":	// List task steps
		if(!TaskName) {Msg("No task is selected."); break;}
		var i,TS= Task[TaskName]; // Get the task steps
		if(!TS[0]) {Msg("Task "+TaskName+" has no steps."); break;}
		var cmt= TS.cmt ? ",  "+TS.cmt : "";
		Msg("Task "+TaskName+cmt);
		for(i=1;i<=TS[0];i++) { // Display all the steps
			Msg("Step #"+i+": "+ObjectToString(TS[i],false));
		}
		break;
	case "loc":		// Display current location
		var mloc= skapi.maplocCur; // Get current location
		var head= Math.round(mloc.head); // Compass heading
		Msg("Current location is "+mloc.sz(3)+", heading "+head);
		break;
	case "log":		// Toggle logging detailed messages
		Log = !Log;
		SetCtlCheck("cbLog",Log);	// Switch the control check box
		Msg("Logging is "+(Log ? "on" : "off"));
		break;
	case "one":		// Toggle one step actions
		One = !One;
		SetCtlCheck("cbOne",One); // Switch the control check box
		Msg("One step is "+(One ? "on" : "off"));
		break;
	case "pause":	// Pause the current task
	case "poz":		// Alternate abbr.
		PauseRes(); // Pause or resume
		break;
	case "poa":		// Toggle pause-on-attack
		PoA = !PoA;
		if(Schema) SetCtlCheck("cbPoA",PoA); // Switch the control check box
		Msg("Pause on Attack is "+(PoA ? "on" : "off"));
		break;
	case "quit": 	// Set quit flag
		Quit= true;
		Msg("Quit flag set");
		break;
	case "save":	// Save configuration settings
		var filename=Title+".cfg";
		SaveCfg(filename);
		Msg("Current configuration saved in "+filename);
		break;
	case "savetl":	// Save task list
		if(!TaskFile) {Msg("There is no task list to save."); break;}
		if(!Task[0]) {Msg("The task list is empty."); break;}
		SaveTask(TaskFile);
		Msg("Current task list saved in "+TaskFile);
		break;
	case "stop":	// Toggle stopping at nav. destination
		Stop = !Stop;
		SetCtlCheck("cbStop",Stop);	// Switch the control check box
		Msg("Stopping is "+(Stop ? "on" : "off"));
		break;
	default: Msg("Unknown comand: "+word[0]);
	}
	word= null;		// Clear command flag
}

// Handler function for the OnControlEvent event.
function OnControlEvent(Panel,Control,Value) {	// This indicates that the control panel was used
	if(Panel!=Title && Panel!="Enter Name") return;	// Ignore if its not our panel
	var SO, val= Value(Control);	// Get the control value
	if(CheckRange(Value("ebVal"),"ebVal")<0) return; // Quit if invalid
	if(Log) Msg("Control name="+Control+", Value="+val);
	switch(Control) {				// Handle the control that was used
	case "pbChat":							// Add a chat step
		if(!TaskName) {Msg("No task selected to edit."); break;}
		if(Value("ebCmt")=="") {	// Do we have a test message?
			Msg("No text to display");
			skapi.GetControlProperty(Title,"ebCmt","Capture"); // Reactivate the edit
			break;
		}
		AddStep("chat",null,Range,Value("ebCmt"));
		break;
	case "pbCncl":					// Cancel new name
		skapi.RemoveControls(Title2); // Remove the name control panel
		skapi.ShowControls(Title,true); // Restore the control panel
		break;
	case "pbDelay":					// Add a delay step
		if(!TaskName) {Msg("No task selected to edit."); break;}
		AddStep("dly",null,Range,Value("ebCmt"));
		break;
	case "pbDelS":					// Delete step
		if(!Step) {Msg("Select step to delete."); break;}
		DeleteStep(Step);		// Delete the current step
		Msg("Deleted step # "+Step);
		if(Step>Task[TaskName][0]) Step--; // Was it the last step?
		ShowStep();				// Display the current step
		break;
	case "pbDelT":					// Delete task
		if(!TaskName) {Msg("No task selected to delete."); break;}
		if(Step) {Msg("Stop the task before deletion."); break;}
		delete Task[TaskName];	// Delete the current task
		Msg("Deleted task "+TaskName);
		TaskName= null, Task[0]--; // Decrement task count
		skapi.GetControlProperty(Title,"cmTask","Clear"); // Clear the menu
		ShowTasks();			// Build the task menu
		break;
	case "pbDoS":					// Do step
		if(!Step) {Msg("Select step to do."); break;}
		DoS= Step;					// Do this step only
		DoStep(Task[TaskName][Step]); // Do the current step
		ShowStep();					// Display the current step
		break;
	case "cbDSoA": OnCommand("dsoa"); // Do dsoa command
		break;
	case "ebECmt":					// Change comment
		if(val) Task[TaskName][Step].cmt= val; // Set new value
		else delete Task[TaskName][Step].cmt; // Remove if null
		Msg("Step comment changed.");
		break;
	case "cbESoM":					// Change stop option
		var opt= Task[TaskName][Step].opt; // Get old value if any
		if(!opt) opt= 0;			// Make sure its a valid number
		Task[TaskName][Step].opt= opt^1; // Set new value for walk bit
		Msg("Step stop flag "+(opt&1 ? "cleared" : "set"));
		break;
	case "ebEVal":					// Change value setting
		if(CheckRange(val,"ebEVal")<0) break; // Quit if invalid
		if(!val || val==1) delete Task[TaskName][Step].val;
		else Task[TaskName][Step].val= parseInt(val); // Set new value
		Msg("Step value changed to "+val);
		break;
	case "cbEWalk":						// Change walk option
		var opt= Task[TaskName][Step].opt; // Get old value if any
		if(!opt) opt= 0;			// Make sure its a valid number
		Task[TaskName][Step].opt= opt^2; // Set new value for walk bit
		Msg("Step walk flag "+(opt&2 ? "cleared" : "set"));
		break;
	case "cmFile": 					// A task file was selected
		if(!val || TaskFile==val) break; // Ignore if null or current selection
		if(Step) StopTask(true);	// Stop step in progress?
		Task= {}, TaskFile= val, TaskName= null; // Rest task list
		skapi.GetControlProperty(Title,"cmTask","Clear"); // Clear the menu
		if(include(val)) {Msg("Warning: '"+val+"' not found."); break;}
		if(!Task[0]) {Msg("Warning: no tasks found in "+val); break;}
		ShowTasks();			// Build the task menu
		var cmt= Task.cmt ? ",  "+Task.cmt : "";
		Msg("File: "+TaskFile+cmt);
		break;
	case "pbFill": ChatMsg("@fillcomps");	// Say @fillcomps online command
		break;
	case "pbFriends": ChatMsg("@friends online"); // Say @friends online command
		break;
	case "pbGoTo":							// Add a GoTo step
		if(!TaskName) {Msg("No task selected to edit."); break;}
		if(Range<1) Range= 1;		// Default?
		var SO= AddStep("goto",skapi.maplocCur.sz(3),Range,Value("ebCmt"));
		var opt= Value("cbSoM")=="True" ? 1 : 0; // Stop flag
		if(Value("cbWalk")=="True") opt |= 2; // Walk flag
		if(opt) SO.opt= opt;		// Add options?
		break;
	case "cbHot": OnCommand("hot");			// Do hot command
		break;
	case "pbHouse": ChatMsg("@house recall"); // Say @house recall command
		break;
	case "pbID": OnCommand("id");			// Do id command
		break;
	case "pbInsS":							// Insert step
		if(!Step) {Msg("Use Add for the first step."); break;}
		InsertStep(Step);			// Insert a blank step
		Msg("Inserted a blank step # "+Step);
		ShowStep();					// Display the current step
		break;
	case "pbJump":							// Add a Jump step
		if(!TaskName) {Msg("No task selected to edit."); break;}
		var head= Math.round(skapi.maplocCur.head);	// Compass heading
		SO= AddStep("jump",head,Range,Value("ebCmt"));
		var opt= Value("cbSoM")=="True" ? 1 : 0; // Stop flag
		if(Value("cbWalk")=="True") opt |= 2; // Walk flag
		if(opt) SO.opt= opt;		// Add options?
		if(DSoA) DoStep(SO);			// Do the added step?
		break;
	case "pbLife": ChatMsg("@lifestone");	// Say @lifestone command
		break;
	case "pbList": OnCommand("list");		// Do list command
		break;
	case "pbLoc": OnCommand("loc");			// Do loc command
		break;
	case "cbLog": OnCommand("log");			// Do log command
		break;
	case "pbMansion": ChatMsg("@house mansion_recall");	// Say @house mansion_recall command
		break;
	case "pbMove":							// Add a Move step
		if(!TaskName) {Msg("No task selected to edit."); break;}
		if(!Selected) {Msg("Use Select command first."); break;}
		var aco= skapi.acoSelected;
		if(!aco) {Msg("No target selected."); break;}
		var give= aco.ocm && (ocmPlayer|ocmNPC) ? 4 : 0; // Use give mode?
		if(!give && !(aco.oty & otyContainer)) {
			Msg("Move target isn't a container or character.");
			return;
		}
		if(aco==skapi.acoChar) give= false;	// Special case, player is main pack
		SO= AddStep("move",aco,Selected.citemStack,Value("ebCmt"));
		SO.sel= Selected.szName, SO.give= give;	// Add move type
		if(DSoA) DoStep(SO);			// Do the added step?
		break;
	case "ebName":					// Set a new name
	case "ebNCmt":					// Set a new name comment
		var name= Value("ebName");	// Get the new name
		if(name=="") {				// Nothing entered?
			Msg("No name entered.");
			skapi.GetControlProperty(Title2,"ebName","Capture"); // Reactivate the edit
			break;
		}
		if(name=="cmt") {			// Valid entered?
			Msg("'cmt' is a reserved name.");
			skapi.GetControlProperty(Title2,"ebName","Capture"); // Reactivate the edit
			break;
		}
		var cmt= Value("ebNCmt");	// Get the new comment
		if(cmt=="Comment") cmt= "";	// Is it still the default?
		skapi.RemoveControls(Title2); // Remove the name control panel
		skapi.ShowControls(Title,true); // Restore the control panel
		AddName(name,cmt);			// Apply the new name
		break;
	case "pbNewF":					// Get a new filename
		if(Step) {Msg("Stop the current task first."); break;}
		AddName= NewFile;			// Set the type of add
		skapi.ShowControls(NameSchema,true); // Display the control panel
		skapi.GetControlProperty(Title2,"ebName","Capture"); // Activate the edit
		break;
	case "pbNewT":					// Get a new task name
		if(Step) {Msg("Stop the current task first."); break;}
		AddName= NewTask;			// Set the type of add
		skapi.ShowControls(NameSchema,true); // Display the control panel
		skapi.GetControlProperty(Title2,"ebName","Capture"); // Activate the edit
		break;
	case "pbNext":					// Select next step
		if(!TaskName) {Msg("No task selected to edit."); break;}
		if(Step>=Task[TaskName][0]) {Msg("No next step."); break;}
		if(!Step) {					// Are we stepping into a task?
			skapi.SetControlProperty(Title,"pbStart","text","Stop Task");
			PauseTask(false);		// Turn Pause on
		} else if(!Pause) {Msg("Can't edit an active task."); break;}
		Step++;						// Increment the step counter
		ShowStep();					// Display the step
		break;
	case "pbNote":					// Add a Note step
		if(!TaskName) {Msg("No task selected to edit."); break;}
		if(Value("ebCmt")=="") { // Do we have a test message?
			Msg("No text for note");
			skapi.GetControlProperty(Title,"ebCmt","Capture"); // Reactivate the edit
			break;
		}
		AddStep("note",null,0,Value("ebCmt"));
		break;
	case "cbOne": OnCommand("one");	// Do one command
		break;
	case "pbOpen":					// Add an Open step
		if(!TaskName) {Msg("No task selected to edit."); break;}
		var aco= skapi.acoSelected;
		if(!aco) {Msg("Nothing is selected."); break;}
		SO= AddStep("open",aco,0,Value("ebCmt"));
		if(DSoA) DoStep(SO);			// Do the added step?
		break;
	case "pbPause": PauseRes();		// Pause/Unpause a task
		break;
	case "cbPoA": OnCommand("poa");	// Do poa command
		break;
	case "pbPort":									// Add an Portal step
		if(!TaskName) {Msg("No task selected to edit."); break;}
		var aco= skapi.acoSelected;
		if(!aco) {Msg("Nothing is selected."); break;}
		SO= AddStep("port",aco,0,Value("ebCmt"));
		if(DSoA) DoStep(SO);			// Do the added step?
		break;
	case "pbPoz":									// Add a Pause step
		if(!TaskName) {Msg("No task selected to edit."); break;}
		AddStep("poz",null,0,Value("ebCmt"));
		break;
	case "pbPrev":									// Select previous step
		if(!TaskName) {Msg("No task selected to edit."); break;}
		if(Step && !Pause) {Msg("Can only edit a paused task."); break;}
		if(Step==1) {Msg("No previous step."); break;}
		if(!Step) {					// Are we stepping into a task?
			skapi.SetControlProperty(Title,"pbStart","text","Stop Task");
			PauseTask(false);		// Turn Pause on
			Step= Task[TaskName][0]; //Get the last step
		} else Step--;				// Decrement the step counter
		ShowStep();					// Display the step
		break;
	case "pbQuit": Quit= true;		// Set quit flag
		Msg("Quit flag set");
		break;
	case "pbRenF":							// Rename the task list
		AddName= RenameFile;		// Set the type of add
		skapi.ShowControls(NameSchema,true); // Display the control panel
		skapi.SetControlProperty(Title2,"ebName","text",TaskFile); // Current filename
		var cmt= Task.cmt ? Task.cmt : "";
		skapi.SetControlProperty(Title2,"ebNCmt","text",cmt); // Current comment
		skapi.GetControlProperty(Title2,"ebName","Capture"); // Activate the edit
		break;
	case "pbSave": OnCommand("save");		// Do save command
		break;
	case "pbSaveF": OnCommand("savetl");	// Do savetl command
		break;
	case "pbSel":							// Add a Select step
		if(!TaskName) {Msg("No task selected to edit."); break;}
		var aco= skapi.acoSelected;
		if(!aco) {Msg("Nothing is selected."); break;}
		if(!aco.fInInventory) {Msg("Select an inventory item."); break;}
		Selected= aco;
		Msg("Selected "+Selected);
		break;
	case "pbSet":					// Set location/heading
		if(!Pause) {Msg("Can only edit a paused task."); break;}
		var SO= Task[TaskName][Step]; // Get current step
		if(SO.cmd=="goto") SO.loc= skapi.maplocCur.sz(3);
		else if(SO.cmd=="jump") {
			SO.loc= Math.round(skapi.maplocCur.head); // Compass heading
		} else {Msg("Only use Set on Go To location or Jump heading."); break;}
		ShowStep();					// Display the step
		break;
	case "pbStart": 				// Start/Stop a task
		if(!TaskName) {Msg("No task has been selected."); break;}
		if(!Step) {					// Not started yet?
			Step= 1, Pause= false;	// Start with first step
			Selected= null;			// Reset
			skapi.SetControlProperty(Title,"pbStart","text","Stop Task");
			Msg("Starting "+TaskName+",  "+Task[TaskName].cmt);
			Timer.cmsec= -1;		// Set timer to fire
			break;
		}
		// If we get this far, we are stopping the task
		StopTask(true);
		break;
	case "cbStop": OnCommand("stop");	// Do stop command
		break;
	case "nbTab":					// A tab was selected
		Tab= val;					// Remember current tab
		if(val<1 || val>2) break;	// Ignore if not Add or Edit
		if(!TaskName) {				// Is a task defined?
			Msg("A task must be selected first");
			skapi.SetControlProperty(Title,"nbTab","activetab",0); // Select Task tab
			break;
		}
		ShowStep();					// Display the current step
		break;
	case "cmTask": 					// A task name was selected
		if(TaskName==val) break;	// Ignore if current selection
		if(Step) StopTask(true);	// Stop step in progress?
		TaskName= val;				// Remember the current name
		if(!TaskName) break;		// Skip if null
		var cmt= Task[TaskName].cmt ? ",  "+Task[TaskName].cmt : "";
		Msg("Task: "+TaskName+cmt);
		break;
	case "pbTest": 					// Display test condition
		Msg("Walk="+Value("cbWalk")+", "+(typeof Value("cbWalk")));
		Msg("Sh:"+skapi.KeyState("{shift}")+", HR:"+skapi.KeyState("{HoldRun}")+", WF:"+skapi.KeyState("{WalkForward}"));
		break;
	case "pbUse":					// Add a Use step
		if(!TaskName) {Msg("No task selected to edit."); break;}
		var aco= skapi.acoSelected;
		if(!aco) {Msg("Nothing is selected."); break;}
		SO= AddStep("use",aco,0,Value("ebCmt"));
		if(Selected) SO.sel= Selected.szName; // Use selected on?
		if(DSoA) DoStep(SO);			// Do the added step?
		break;
	case "pbWait":					// Add a Wait step
		if(!TaskName) {Msg("No task selected to edit."); break;}
		var aco= skapi.acoSelected;
		if(!aco) {Msg("Nothing is selected."); break;}
		AddStep("wait",aco,0,Value("ebCmt"));
		break;
	}
	if(Control!="pbSel") Selected= null; // Reset selection?
}

// Handler function for the OnControlProperty event.
function OnControlProperty(Panel,Control,Property,Value) {	// GetControlProperty was called
	if(Panel!=Title) return;	// Ignore if its not our panel
	if(Control=="sRange" && Property=="SliderPosition") Range= Value;
	if(!Log) return;
	Msg("Control="+Control+", Property="+Property+", Value="+Value);
	if(typeof Value=="number" && Value>0) Msg("Value="+Hex(Value));
}

// Handler function for the OnEndPortalSelf event.
function OnEndPortalSelf(aco) {
	if(WaitFor!=true) return; // Did we use a portal step?
	WaitFor=null; 			// Clear flag
	if(Deb) Msg("OnEndPortalSelf called.");
	DoneStep();				// Advance step if appropriate
}

// Handler function for the OnHotkey event.
function OnHotkey(cmid,vk) { // A hotkey has been pressed
	if(skapi.fInChatBuffer) return; // Ignore chat keystrokes
	var cmd= HotKeys[cmid];
	if(!cmd) {Msg("Unknown hotkey: '"+cmid+"'."); return;}
	OnCommand(cmd);			// Do the command
}

// Handler function for the OnLeaveVendor event.
function OnLeaveVendor() {	// This indicates that the vendor is no longer available
	Vendor= null;			// Remove vendor object
}

// Handler function for the OnMeleeLastAttacker event.
function OnMeleeLastAttacker(aco) {
	if(!PoA) return;		// Ignore attacks?
	if(!Step || Pause) return; // Are we running a step?
	PauseTask(false);		// Pause the task
	Msg("Task paused due to attack.");
}

// Handler function for the OnNavStop event.
function OnNavStop(nsc) {
	if(Log) Msg("Navigation ended, code="+nsc);
	if(!Nav) return;
	Nav= false;			// Clear the flag
	switch(nsc) {
	case nscArrived: DoneStep();	// Advance step if appropriate
		break;
	case nscTimeout: Msg("Goto timeout, pausing task.");
		PauseTask(true)
		break;
	case nscCanceled:
		break;
	default: Msg("Unknown nav code: "+nsc);
	}

}

// Handler function for the OnObjectCreate event.
function OnObjectCreate(aco) {
	if(!Step) return;		// Are we runnng a task?
	if(aco.szName!=WaitFor) return;	// Ignore create?
	Msg("Found "+WaitFor);
	WaitFor= null;			// Reset
	DoneStep();				// Advance step if appropriate
}

// Handler function for the OnOpenContainer event.
function OnOpenContainer(aco) {
}

// Handler function for the OnRemoveFromInventory event.
function OnRemoveFromInventory(aco) {
	if(Nav) return; // Ignore if moving
	if(Deb) Msg("OnRemoveFromInventory called.");
	DoneStep();		// Advance step if appropriate
}

// Handler function for the OnSpellFailSelf event.
function OnSpellFailSelf(arc) { // Something failed
	if(Log) Msg("Action result code="+arc);
	switch(arc) {			// Process the result code if relevent
	case arcCantMoveToObject: // We blocked from reaching an object
		break;
	case arcTooBusy:		// We started an action too soon
		break;
	}
}

// Handler function for the OnTimer event.
function OnTimer(to) {
	if(to.tag!="step") return; // Ignore if its not the step timer
	if(Deb) Msg("OnTimer called.");
	if(Tab==2 && !Repeat) ShowStep(); // Update panel?
	else if(Step) DoStep();		// Perform the next task step?
}
